Angular ToolBar Component

The ToolBar component for Angular represents a toolbar where different tools (including widgets) can be automatically added. By default, jqxToolBar supports the widgets Button, ToggleButton, DropDownList, ComboBox and Input but custom tools can also be added.

1. Installation

The easiest way to get started with jQWidgets UI for Angular is to use the Angular CLI Tool. To scaffold your project structure, follow its installation instructions.

npm install -g @angular/cli
ng new jqwidgets-project
cd jqwidgets-project

Install jQWidgets

jQWidgets Angular UI comes packaged with Angular CLI schematics to make creating Angular applications easier. Schematics are included with both @angular/cdk and jqwidgets-ng. Once you install the npm packages, they will be available through the Angular CLI.

Angular CLI supports the addition of packages through the ng add command. The ng add command provides faster and more user-friendly package installation. To install the jQWidgets UI for Angular package, use ng add and add the name of the NPM package:

ng add jqwidgets-ng

Alternatively, you can use the standard installation (Manual Setup)

jQWidgets UI for Angular is distributed as jqwidgets-ng NPM package

  1. Download and install the package.
    npm install jqwidgets-ng
  2. Adding CSS reference

    The following CSS file is available in ../node_modules/jqwidgets-ng/ package folder. This can be referenced in [src/styles.css] using following code.

    @import 'jqwidgets-ng/jqwidgets/styles/jqx.base.css';

    Another way to achieve the same is to edit the angular.json file and in the styles add the style.

    "styles": [
    	"node_modules/jqwidgets-ng/jqwidgets/styles/jqx.base.css"
    ]
    

2. Add the HTML for jQWidgets component in src/app/app.component.html

app.component.html


<jqxToolbar [theme]="'fluent'"
	[width]="getWidth()" [height]="35"
    [tools]="tools" [initTools]="initTools">
</jqxToolBar>	

3. Setup Component Logic

app.component.ts


import { Component, ElementRef, ViewEncapsulation } from '@angular/core';

import { jqxToolBarModule, jqxToolBarComponent } from 'jqwidgets-ng/jqxtoolbar';
@Component({
    selector: 'app-root',
    imports: [jqxToolBarModule],
    standalone: true,
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css'],
    encapsulation: ViewEncapsulation.None
})

export class AppComponent {
    getWidth(): any {
        if (document.body.offsetWidth < 700) {
            return '90%';
        }

        return 700;
    }

    tools: string = 'toggleButton toggleButton toggleButton | toggleButton | dropdownlist combobox | input | custom';
    initTools: any = (type: string, index: number, tool: any, menuToolIninitialization): void => {
        let icon = document.createElement('div');
        if (type == "toggleButton") {
            icon.className = 'jqx-editor-toolbar-icon jqx-editor-toolbar-icon-arctic buttonIcon ';
        }
        switch (index) {
            case 0:
                icon.className += "jqx-editor-toolbar-icon-bold jqx-editor-toolbar-icon-bold-arctic";
                icon.setAttribute("title", "Bold");
                tool[0].appendChild(icon);
                break;
            case 1:
                icon.className += "jqx-editor-toolbar-icon-italic jqx-editor-toolbar-icon-italic-arctic";
                icon.setAttribute("title", "Italic");
                tool[0].appendChild(icon);
                break;
            case 2:
                icon.className += "jqx-editor-toolbar-icon-underline jqx-editor-toolbar-icon-underline-arctic";
                icon.setAttribute("title", "Underline");
                tool[0].appendChild(icon);
                break;
            case 3:
                tool.jqxToggleButton({ width: 80, toggled: true });
                tool.text("Enabled");
                tool.on("click", () => {
                    let toggled = tool.jqxToggleButton("toggled");
                    if (toggled) {
                        tool.text("Enabled");
                    } else {
                        tool.text("Disabled");
                    }
                });
                break;
            case 4:
                tool.jqxDropDownList({ width: 130, source: ["<span style='font-family: Courier New;'>Courier New</span>", "<span style='font-family: Times New Roman;'>Times New Roman</span>", "<span style='font-family: Verdana;'>Verdana</span>"], selectedIndex: 1 });
                break;
            case 5:
                tool.jqxComboBox({ width: 50, source: [8, 9, 10, 11, 12, 14, 16, 18, 20], selectedIndex: 3 });
                break;
            case 6:
                tool.jqxInput({ width: 200, placeHolder: "Type here to search..." });
                break;
            case 7:
                let button = document.createElement('div');
                let img = document.createElement('img');
                img.src = 'https://www.jqwidgets.com/angular/images/administrator.png'
                img.title = 'Custom tool';
                button.appendChild(img);
                tool[0].appendChild(button);
                tool.jqxButton({ height: 15 });
                break;
        }
    };
}

Summary

jQWidgets UI for Angular provides an easy way to integrate robust UI components into your Angular project. By using either the ng add command or manual setup, you can quickly get started. Once the setup is complete, you can add the desired jQWidgets components and configure them in your Angular components to match your application requirements.

ToolBar API

API Reference of the jQWidgets ToolBar component for Angular: ToolBar API

Vue UI Components Documentation

Vue ToolBar Component

The ToolBar component for Vue represents a toolbar where different tools (including widgets) can be automatically added. By default, jqxToolBar supports the widgets Button, ToggleButton, DropDownList, ComboBox and Input but custom tools can also be added.

Prerequisites

Refer to Vue Getting Started before you start with this help topic.

Configuration

After you have created your App.vue file, here is how you should structure it:

The ToolBar component for Vue requires the following import:

import JqxToolbar from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxtoolbar.vue';

Add the jqxToolBar component to the components section of the the Vue class:

 components: {
JqxToolbar
},

Template

The App.vue has a <template> structural tag where we determine the application structure. There we will also set the tags for the new components - <JqxToolBar/>

<template>
<JqxToolbar :width="width" :height="height"
:tools="tools" :initTools="initTools">
</JqxToolbar>
</template>

Properties

The properties of the <JqxToolBar/> component are defined in the data member of the Vue class. We should put them in the return object of the data function:

data: function () {
return {
width: 500,
height: 35,
tools: 'toggleButton toggleButton toggleButton | toggleButton | dropdownlist combobox | input | custom'
}
}

Events

The events in Vue are set as an attribute with @ prefix, for example:

<JqxToolbar @open="onOpen()"
:width="width" :height="height"
:tools="tools" :initTools="initTools">
</JqxToolbar>

All events that are bound to a component are implemented in the methods member of the Vue class.

methods: {
onOpen: function () {
// Do something...
}
}

Methods

To use a component's method we should have its reference. In Vue we refer to a component by the special $refs property. Before that we need to add the desired name reference to that component:

<JqxToolBar ref="toolbar"></JqxToolBar>

Here how you can use a component's method:

this.$refs.toolbar.onOpen();

If we want to add additional methods we should also implement them in the methods member.

methods: {
// Add here all used callbacks and/or events
onOpen: function () {
// Do something...
let tools = this.refs.toolbar.getTools();
alert(tools);
},
initTools: function (type, index, tool, menuToolIninitialization) {
const icon = document.createElement('div');
if (type == 'toggleButton') {
icon.className = 'jqx-editor-toolbar-icon jqx-editor-toolbar-icon-arctic buttonIcon ';
}
switch (index) {
case 0:
icon.className += 'jqx-editor-toolbar-icon-bold jqx-editor-toolbar-icon-bold-arctic';
icon.setAttribute('title', 'Bold');
tool[0].appendChild(icon);
break;
case 1:
icon.className += 'jqx-editor-toolbar-icon-italic jqx-editor-toolbar-icon-italic-arctic';
icon.setAttribute('title', 'Italic');
tool[0].appendChild(icon);
break;
case 2:
icon.className += 'jqx-editor-toolbar-icon-underline jqx-editor-toolbar-icon-underline-arctic';
icon.setAttribute('title', 'Underline');
tool[0].appendChild(icon);
break;
case 3:
tool.jqxToggleButton({ width: 80, toggled: true });
tool.text('Enabled');
tool.on('click', () => {
const toggled = tool.jqxToggleButton('toggled');
if (toggled) {
tool.text('Enabled');
} else {
tool.text('Disabled');
}
});
break;
case 4:
tool.jqxDropDownList({ width: 130, source: ["<span style='font-family: Courier New;'>Courier New</span>", "<span style='font-family: Times New Roman;'>Times New Roman</span>", "<span style='font-family: Verdana;'>Verdana</span>"], selectedIndex: 1 });
break;
case 5:
tool.jqxComboBox({ width: 50, source: [8, 9, 10, 11, 12, 14, 16, 18, 20], selectedIndex: 3 });
break;
case 6:
tool.jqxInput({ width: 200, placeHolder: 'Type here to search...' });
break;
case 7:
const button = document.createElement('div');
const img = document.createElement('img');
img.src = 'images/administrator.png'
img.title = 'Custom tool';
button.appendChild(img);
tool[0].appendChild(button);
tool.jqxButton({ height: 15 });
break;
}
}
}

In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate member. It depends on the case.

If you have followed the above steps, you App.vue file would look like this:

App.vue:

<template>
<JqxToolbar ref="toolbar" @open="onOpen()"
:width="width" :height="height"
:tools="tools" :initTools="initTools">
</JqxToolbar>
</template>
<script>
// Import the components that will be used
import JqxToolbar from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxtoolbar.vue';
export default {
components: {
// Adding imported widgets here
JqxToolbar
},
data: function () {
// Define properties which will use in the widget
return {
width: 500,
height: 35,
tools: 'toggleButton toggleButton toggleButton | toggleButton | dropdownlist combobox | input | custom'
}
},
beforeCreate: function () {
// Add here any data where you want to transform before components be rendered
},
methods: {
// Add here all used callbacks and/or events
onOpen: function () {
// Do something...
let tools = this.refs.toolbar.getTools();
alert(tools);
},
initTools: function (type, index, tool, menuToolIninitialization) {
const icon = document.createElement('div');
if (type == 'toggleButton') {
icon.className = 'jqx-editor-toolbar-icon jqx-editor-toolbar-icon-arctic buttonIcon ';
}
switch (index) {
case 0:
icon.className += 'jqx-editor-toolbar-icon-bold jqx-editor-toolbar-icon-bold-arctic';
icon.setAttribute('title', 'Bold');
tool[0].appendChild(icon);
break;
case 1:
icon.className += 'jqx-editor-toolbar-icon-italic jqx-editor-toolbar-icon-italic-arctic';
icon.setAttribute('title', 'Italic');
tool[0].appendChild(icon);
break;
case 2:
icon.className += 'jqx-editor-toolbar-icon-underline jqx-editor-toolbar-icon-underline-arctic';
icon.setAttribute('title', 'Underline');
tool[0].appendChild(icon);
break;
case 3:
tool.jqxToggleButton({ width: 80, toggled: true });
tool.text('Enabled');
tool.on('click', () => {
const toggled = tool.jqxToggleButton('toggled');
if (toggled) {
tool.text('Enabled');
} else {
tool.text('Disabled');
}
});
break;
case 4:
tool.jqxDropDownList({ width: 130, source: ["<span style='font-family: Courier New;'>Courier New</span>", "<span style='font-family: Times New Roman;'>Times New Roman</span>", "<span style='font-family: Verdana;'>Verdana</span>"], selectedIndex: 1 });
break;
case 5:
tool.jqxComboBox({ width: 50, source: [8, 9, 10, 11, 12, 14, 16, 18, 20], selectedIndex: 3 });
break;
case 6:
tool.jqxInput({ width: 200, placeHolder: 'Type here to search...' });
break;
case 7:
const button = document.createElement('div');
const img = document.createElement('img');
img.src = 'images/administrator.png'
img.title = 'Custom tool';
button.appendChild(img);
tool[0].appendChild(button);
tool.jqxButton({ height: 15 });
break;
}
}
}
}
</script>
<style>
</style>

ToolBar Example

<template>
<div>
<JqxToolbar ref="myToolbar"
:width="width" :height="35"
:tools="tools" :initTools="initTools">
</JqxToolbar>
<div style="margin-top: 50px"></div>
<JqxButton @click="addToggleBtnOnClick()" :width="150">Add a Toggle Button</JqxButton>
<JqxButton @click="addCustomToolBtnOnClick()" :width="150">Add a Custom Tool</JqxButton>
<div style="margin-top: 10px; margin-bottom: 2px">
Insert position:
</div>
<JqxDropDownList ref="myDropDownList"
:width="150" :height="22" :source="['first','last']"
:selectedIndex="1" :autoDropDownHeight="true">
</JqxDropDownList>
<div style="margin-top: 50px"></div>
<JqxButton @click="disableToolBtnOnClick()" :width="150">Disable Tool</JqxButton>
<JqxButton @click="enableToolBtnOnClick()" :width="150">Enable Tool</JqxButton>
<JqxButton @click="destroyToolBtnOnClick()" :width="150">Destroy Tool</JqxButton>
<div style="margin-top: 10px; margin-bottom: 2px">
Tool index:
</div>
<JqxNumberInput ref="myNumberInput"
:width="50" :height="25" :decimal="0"
:decimalDigits="0" :inputMode="'simple'">
</JqxNumberInput>
</div>
</template>
<script>
import JqxToolbar from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxtoolbar.vue';
import JqxButton from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxbuttons.vue';
import JqxNumberInput from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxnumberinput.vue';
import JqxDropDownList from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxdropdownlist.vue';
export default {
components: {
JqxToolbar,
JqxButton,
JqxNumberInput,
JqxDropDownList
},
data: function () {
return {
width: 500,
tools: 'toggleButton toggleButton toggleButton | toggleButton | dropdownlist combobox | input',
countries: ['Argentina', 'Austria', 'Canada', 'China', 'France', 'Germany', 'Japan', 'Mexico', 'Spain', 'Sweden', 'Switzerland', 'UK', 'USA']
}
},
methods: {
initTools: function (type, index, tool, menuToolIninitialization) {
const icon = document.createElement('div');
if (type == 'toggleButton') {
icon.className = 'jqx-editor-toolbar-icon buttonIcon ';
}
switch (index) {
case 0:
icon.className += 'jqx-editor-toolbar-icon-bold';
icon.setAttribute('title', 'Bold');
tool[0].appendChild(icon);
break;
case 1:
icon.className += 'jqx-editor-toolbar-icon-italic';
icon.setAttribute('title', 'Italic');
tool[0].appendChild(icon);
break;
case 2:
icon.className += 'jqx-editor-toolbar-icon-underline';
icon.setAttribute('title', 'Underline');
tool[0].appendChild(icon);
break;
case 3:
tool.jqxToggleButton({ width: 80, toggled: true });
tool[0].innerText = 'Enabled';
tool.on('click', () => {
let toggled = tool.jqxToggleButton('toggled');
if (toggled) {
tool.text('Enabled');
} else {
tool.text('Disabled');
}
});
break;
case 4:
tool.jqxDropDownList({
width: 130, source: ['<span style="font-family: Courier New;">Courier New</span>', '<span style="font-family: Times New Roman;">Times New Roman</span>', '<span style="font-family: Verdana;">Verdana</span>'], selectedIndex: 1
});
break;
case 5:
tool.jqxComboBox({ width: 50, source: [8, 9, 10, 11, 12, 14, 16, 18, 20], selectedIndex: 3 });
break;
case 6:
tool.jqxInput({ width: 200, placeHolder: 'Type here to search...' });
break;
}
},
addToggleBtnOnClick: function () {
const position = this.$refs.myDropDownList.val();
this.$refs.myToolbar.addTool('toggleButton', position, false, (type, tool, menuToolIninitialization) => {
const width = menuToolIninitialization ? '95%' : 50;
tool.jqxToggleButton({ width: width, toggled: false });
tool.text('Off');
tool.on('click', () => {
const toggled = tool.jqxToggleButton('toggled');
toggled ? tool.text('On') : tool.text('Off');
});
});
},
addCustomToolBtnOnClick: function () {
const position = this.$refs.myDropDownList.val();
const country = this.countries[Math.floor(Math.random() * this.countries.length)];
this.$refs.myToolbar.addTool('custom', position, false, (type, tool, menuToolIninitialization) => {
tool.append('<img src="images/' + country + '.png" style="float: left; clear: both;" />');
if (menuToolIninitialization) {
tool.find('img').css('margin-right', '10px');
tool.find('img').css('margin-top', '4px');
tool.append('<div style="float: left; height: 100%; vertical-align: middle;">' + country + '</div>');
} else {
tool.attr('title', 'Flag of ' + country);
}
});
},
disableToolBtnOnClick: function () {
const toolIndex = this.$refs.myNumberInput.val();
this.$refs.myToolbar.disableTool(toolIndex, true);
},
enableToolBtnOnClick: function () {
const toolIndex = this.$refs.myNumberInput.val();
this.$refs.myToolbar.disableTool(toolIndex, false);
},
destroyToolBtnOnClick: function () {
const toolIndex = this.$refs.myNumberInput.val();
this.$refs.myToolbar.destroyTool(toolIndex);
}
}
}
</script>
<style>
.jqx-button:not(.jqx-toolbar-tool) {
display: inline-block;
margin-right: 5px;
}
.buttonIcon {
margin: -5px 0 0 -3px;
width: 16px;
height: 17px;
}
.jqx-listbox {
z-index: 999999 !important;
}
</style>

Run Code

React UI Components Documentation

ReactJS ToolBar Component

The ToolBar component for ReactJS represents a toolbar where different tools (including widgets) can be automatically added. By default, jqxToolBar supports the widgets Button, ToggleButton, DropDownList, ComboBox and Input but custom tools can also be added.

Prerequisites

Refer to ReactJS Getting Started before you start with this help topic.

Configuration

The ToolBar component for ReactJS requires the following imports.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxToolbar from 'jqwidgets-react/react_jqxtoolbar.js';

Then we create our component class. Properties and methods are put as ReactJS props.

Finally we render our class in the desired HTML element:

 
ReactDOM.render(<App />, document.getElementById('app'));

Events Methods & Properties

In order to bind to any event, change any property or call any method, we need a reference to the component.
For that we use the ReactJS "ref" Callback Attribute:

 
<JqxToolBar ref='myToolBar' width={800} height={35}...../>

Now, when we have a reference, we need to call the desired event/property/method.
This is done in the componentDidMount() ReactJS Component Lifecycle method.

Events

The open event is triggered when the user selects an item.

The following example demonstrates how to add an event listener:

Methods & Properties

This is how you call methods & props:

 
//Get Methods
let tools = this.refs.myToolbar.enable();
//Render Method
this.refs.myToolbar.render();
//Get Properties
let height = this.refs.myToolbar.height();
//Set Properties
this.refs.myToolbar.height(50);

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

 
this.refs.myToolbar.setOptions({
minimizeWidth: 100, width: 300, height: 50
})

Every component also have a method getOptions which returns a object containing the component settings.

 
let options = this.refs.myToolbar.getOptions();

ToolBar Examples

Overview

The following example demonstrates how to create a ToolBar component.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxToolBar from 'jqwidgets-react/react_jqxtoolbar.js';
class App extends React.Component {
render () {
let tools = 'toggleButton toggleButton toggleButton | toggleButton | dropdownlist combobox | input | custom';
let initTools = (type, index, tool, menuToolIninitialization) => {
let icon = document.createElement('div');
if (type == "toggleButton") {
icon.className = 'jqx-editor-toolbar-icon jqx-editor-toolbar-icon-arctic buttonIcon ';
}
switch (index) {
case 0:
icon.className += "jqx-editor-toolbar-icon-bold jqx-editor-toolbar-icon-bold-arctic";
icon.setAttribute("title", "Bold");
tool[0].appendChild(icon);
break;
case 1:
icon.className += "jqx-editor-toolbar-icon-italic jqx-editor-toolbar-icon-italic-arctic";
icon.setAttribute("title", "Italic");
tool[0].appendChild(icon);
break;
case 2:
icon.className += "jqx-editor-toolbar-icon-underline jqx-editor-toolbar-icon-underline-arctic";
icon.setAttribute("title", "Underline");
tool[0].appendChild(icon);
break;
case 3:
tool.jqxToggleButton({ width: 80, toggled: true });
tool[0].innerText = "Enabled";
tool.on("click", () =>
{
let toggled = tool.jqxToggleButton("toggled");
if (toggled)
{
tool.text("Enabled");
} else
{
tool.text("Disabled");
}
});
break;
case 4:
tool.jqxDropDownList({ width: 130, source: ["<span style='font-family: Courier New;'>Courier New</span>", "<span style='font-family: Times New Roman;'>Times New Roman</span>", "<span style='font-family: Verdana;'>Verdana</span>"], selectedIndex: 1 });
break;
case 5:
tool.jqxComboBox({ width: 50, source: [8, 9, 10, 11, 12, 14, 16, 18, 20], selectedIndex: 3 });
break;
case 6:
tool.jqxInput({ width: 200, placeHolder: "Type here to search..." });
break;
case 7:
let button = document.createElement('div');
button.innerHTML = "<img src='images/administrator.png' title='Custom tool' />";
tool[0].appendChild(button);
tool.jqxButton({ height: 15 });
break;
}
}
return (
<JqxToolBar
width={800} height={35}
initTools={initTools} tools={tools}
/>
)
}
}
ReactDOM.render(<App />, document.getElementById('app'));

Disabled ToolBar

The following example demonstrates how to disable the ToolBar component.

 
import React from 'react';
import ReactDOM from 'react-dom';
import JqxToolBar from 'jqwidgets-react/react_jqxtoolbar.js';
class App extends React.Component {
render () {
let tools = 'toggleButton toggleButton toggleButton | toggleButton | dropdownlist combobox | input | custom';
let initTools = (type, index, tool, menuToolIninitialization) => {
let icon = document.createElement('div');
if (type == "toggleButton") {
icon.className = 'jqx-editor-toolbar-icon jqx-editor-toolbar-icon-arctic buttonIcon ';
}
switch (index) {
case 0:
icon.className += "jqx-editor-toolbar-icon-bold jqx-editor-toolbar-icon-bold-arctic";
icon.setAttribute("title", "Bold");
tool[0].appendChild(icon);
break;
case 1:
icon.className += "jqx-editor-toolbar-icon-italic jqx-editor-toolbar-icon-italic-arctic";
icon.setAttribute("title", "Italic");
tool[0].appendChild(icon);
break;
}
}
return (
<JqxToolBar
disabled={true}
width={800} height={35}
initTools={initTools} tools={tools}
/>
)
}
}
ReactDOM.render(<App />, document.getElementById('app'));

ToolBar API

API Reference of the jQWidgets ToolBar component for React: ToolBar API